Retrieve a Google Cloud KMS configurations for all clusters and SVMs
Accesses Google Cloud KMS configurations for all clusters and SVMs to manage key management settings across your environment.
HTTP method and endpoint
GET /security/gcp-kms
Introduced in
ONTAP 9.9
Usage notes
Retrieves Google Cloud KMS configurations for all clusters and SVMs.
Related ONTAP commands
-
security key-manager external gcp show -
security key-manager external gcp check
Parameters
| Name | Type | In | Required | Description |
|---|---|---|---|---|
key_name |
string |
query |
False |
Filter by key_name |
port |
integer |
query |
False |
Filter by port
|
oauth_url |
string |
query |
False |
Filter by oauth_url
|
oauth_host |
string |
query |
False |
Filter by oauth_host
|
scope |
string |
query |
False |
Filter by scope |
verify_ip |
boolean |
query |
False |
Filter by verify_ip
|
proxy_host |
string |
query |
False |
Filter by proxy_host |
google_reachability.code |
string |
query |
False |
Filter by google_reachability.code |
google_reachability.reachable |
boolean |
query |
False |
Filter by google_reachability.reachable |
google_reachability.message |
string |
query |
False |
Filter by google_reachability.message |
key_ring_name |
string |
query |
False |
Filter by key_ring_name |
project_id |
string |
query |
False |
Filter by project_id |
proxy_port |
integer |
query |
False |
Filter by proxy_port |
proxy_username |
string |
query |
False |
Filter by proxy_username |
proxy_type |
string |
query |
False |
Filter by proxy_type |
key_ring_location |
string |
query |
False |
Filter by key_ring_location |
state.cluster_state |
boolean |
query |
False |
Filter by state.cluster_state |
state.code |
string |
query |
False |
Filter by state.code |
state.message |
string |
query |
False |
Filter by state.message |
uuid |
string |
query |
False |
Filter by uuid |
svm.uuid |
string |
query |
False |
Filter by svm.uuid |
svm.name |
string |
query |
False |
Filter by svm.name |
caller_account |
string |
query |
False |
Filter by caller_account
|
ekmip_reachability.message |
string |
query |
False |
Filter by ekmip_reachability.message |
ekmip_reachability.node.name |
string |
query |
False |
Filter by ekmip_reachability.node.name |
ekmip_reachability.node.uuid |
string |
query |
False |
Filter by ekmip_reachability.node.uuid |
ekmip_reachability.reachable |
boolean |
query |
False |
Filter by ekmip_reachability.reachable |
ekmip_reachability.code |
string |
query |
False |
Filter by ekmip_reachability.code |
privileged_account |
string |
query |
False |
Filter by privileged_account
|
verify_host |
boolean |
query |
False |
Filter by verify_host
|
cloudkms_host |
string |
query |
False |
Filter by cloudkms_host
|
fields |
array[string] |
query |
False |
Specify the fields to return. |
max_records |
integer |
query |
False |
Limit the number of records returned. |
return_timeout |
integer |
query |
False |
The number of seconds to allow the call to execute before returning. When iterating over a collection, the default is 15 seconds. ONTAP returns earlier if either max records or the end of the collection is reached.
|
return_records |
boolean |
query |
False |
The default is true for GET calls. When set to false, only the number of records is returned.
|
order_by |
array[string] |
query |
False |
Order results by specified fields and optional [asc |
Response
Status: 200, Ok
| Name | Type | Description |
|---|---|---|
_links |
||
num_records |
integer |
Number of records |
records |
array[gcp_kms] |
Example response
{
"_links": {
"next": {
"href": "/api/resourcelink"
},
"self": {
"href": "/api/resourcelink"
}
},
"num_records": 1,
"records": [
{
"_links": {
"self": {
"href": "/api/resourcelink"
}
},
"caller_account": "myaccount@myproject.com",
"cloudkms_host": "cloudkms.googleapis.com",
"ekmip_reachability": [
{
"code": "346758",
"message": "embedded KMIP server status unavailable on node.",
"node": {
"_links": {
"self": {
"href": "/api/resourcelink"
}
},
"name": "node1",
"uuid": "1cd8a442-86d1-11e0-ae1c-123478563412"
}
}
],
"google_reachability": {
"code": "346758",
"message": "Google Cloud KMS is not reachable from all nodes - <reason>."
},
"key_name": "cryptokey1",
"key_ring_location": "global",
"key_ring_name": "gcpapp1-keyring",
"oauth_host": "oauth2.googleapis.com",
"oauth_url": "https://oauth2.googleapis.com/token",
"port": 443,
"privileged_account": "myserviceaccount@myproject.iam.gserviceaccount.com",
"project_id": "gcpapp1",
"proxy_host": "proxy.eng.com",
"proxy_port": 1234,
"proxy_type": "http",
"proxy_username": "proxyuser",
"scope": "string",
"state": {
"code": "346758",
"message": "Top-level internal key protection key (KEK) is unavailable on the following nodes with the associated reasons: Node: node1. Reason: No volumes created yet for the SVM. Wrapped KEK status will be available after creating encrypted volumes."
},
"svm": {
"_links": {
"self": {
"href": "/api/resourcelink"
}
},
"name": "svm1",
"uuid": "02c9e252-41be-11e9-81d5-00a0986138f7"
},
"uuid": "1cd8a442-86d1-11e0-ae1c-123478563412",
"verify_host": "",
"verify_ip": ""
}
]
}
Error
Status: Default
ONTAP Error Response Codes
| Error Code | Description |
|---|---|
65537551 |
Top-level internal key protection key (KEK) unavailable on one or more nodes. |
65537552 |
Embedded KMIP server status not available. |
65537730 |
The Google Cloud Key Management Service is unreachable from one or more nodes. |
Also see the table of common errors in the Response body overview section of this documentation.
| Name | Type | Description |
|---|---|---|
error |
Example error
{
"error": {
"arguments": [
{
"code": "string",
"message": "string"
}
],
"code": "4",
"message": "entry doesn't exist",
"target": "uuid"
}
}
Definitions
See Definitions
href
| Name | Type | Description |
|---|---|---|
href |
string |
_links
| Name | Type | Description |
|---|---|---|
next |
||
self |
_links
| Name | Type | Description |
|---|---|---|
self |
node
| Name | Type | Description |
|---|---|---|
_links |
||
name |
string |
|
uuid |
string |
ekmip_reachability
Provides the connectivity status for the given SVM on the given node to all EKMIP servers configured on all nodes of the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the fields query parameter or GET for all advanced properties is enabled.
| Name | Type | Description |
|---|---|---|
code |
string |
Code corresponding to the error message. Returns a 0 if a given SVM is able to communicate to the EKMIP servers of all of the nodes in the cluster. |
message |
string |
Error message set when cluster-wide EKMIP server availability from the given SVM and node is false. |
node |
||
reachable |
boolean |
Set to true if the given SVM on the given node is able to communicate to all EKMIP servers configured on all nodes in the cluster. |
google_reachability
Indicates whether or not the Google Cloud KMS is reachable from all nodes in the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the fields query parameter or GET for all advanced properties is enabled.
| Name | Type | Description |
|---|---|---|
code |
string |
Code corresponding to the error message. Returns a 0 if Google Cloud KMS is reachable from all nodes in the cluster. |
message |
string |
Set to the error message when 'reachable' is false. |
reachable |
boolean |
Set to true if the Google Cloud KMS is reachable from all nodes of the cluster. |
state
Google Cloud Key Management Services is a cloud key management service (KMS) that provides a secure store for encryption keys. This object indicates whether or not the Google Cloud KMS key protection is available on all nodes in the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the fields query parameter or GET for all advanced properties is enabled.
| Name | Type | Description |
|---|---|---|
cluster_state |
boolean |
Set to true when Google Cloud KMS key protection is available on all nodes of the cluster. |
code |
string |
Error code corresponding to the status message. Returns 0 if Google Cloud KMS key protection is available in all nodes of the cluster. |
message |
string |
Error message set when top-level internal key protection key (KEK) availability on cluster is false. |
svm
SVM, applies only to SVM-scoped objects.
| Name | Type | Description |
|---|---|---|
_links |
||
name |
string |
The name of the SVM. This field cannot be specified in a PATCH method. |
uuid |
string |
The unique identifier of the SVM. This field cannot be specified in a PATCH method. |
gcp_kms
| Name | Type | Description |
|---|---|---|
_links |
||
caller_account |
string |
Google Cloud KMS caller account email |
cloudkms_host |
string |
Google Cloud KMS host subdomain. |
ekmip_reachability |
array[ekmip_reachability] |
|
google_reachability |
Indicates whether or not the Google Cloud KMS is reachable from all nodes in the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the |
|
key_name |
string |
Key Identifier of Google Cloud KMS key encryption key. |
key_ring_location |
string |
Google Cloud KMS key ring location. |
key_ring_name |
string |
Google Cloud KMS key ring name of the deployed Google Cloud application. |
oauth_host |
string |
Open authorization server host name. |
oauth_url |
string |
Open authorization URL for the access token. |
port |
integer |
Authorization server and Google Cloud KMS port number. |
privileged_account |
string |
Google Cloud KMS account to impersonate. |
project_id |
string |
Google Cloud project (application) ID of the deployed Google Cloud application that has appropriate access to the Google Cloud KMS. |
proxy_host |
string |
Proxy host name. |
proxy_port |
integer |
Proxy port number. |
proxy_type |
string |
Type of proxy. |
proxy_username |
string |
Proxy username. |
scope |
string |
Set to "svm" for interfaces owned by an SVM. Otherwise, set to "cluster". |
state |
Google Cloud Key Management Services is a cloud key management service (KMS) that provides a secure store for encryption keys. This object indicates whether or not the Google Cloud KMS key protection is available on all nodes in the cluster.
This is an advanced property; there is an added computational cost to retrieving its value. The property is not populated for either a collection GET or an instance GET unless it is explicitly requested using the |
|
svm |
SVM, applies only to SVM-scoped objects. |
|
uuid |
string |
A unique identifier for the Google Cloud KMS. |
verify_host |
boolean |
Verify the identity of the Google Cloud KMS host name. |
verify_ip |
boolean |
Verify identity of Google Cloud KMS IP address. |
error_arguments
| Name | Type | Description |
|---|---|---|
code |
string |
Argument code |
message |
string |
Message argument |
returned_error
| Name | Type | Description |
|---|---|---|
arguments |
array[error_arguments] |
Message arguments |
code |
string |
Error code |
message |
string |
Error message |
target |
string |
The target parameter that caused the error. |